<?php

/**
 * Created by PhpStorm.
 * Date: 2017/3/31
 * Time: 14:02
 */

namespace General\Controllers\LandingPage\Transformers;

use General\Models\LandingPage\LandingPageLink;

class LinkTransformer
{
    public function transform($item)
    {
        return [
            'id' => $item->id,
            'channel_id' => $item->channel_id,
            'title' => $item->title,
            'name' => $item->name,
            'bid' => $item->bid,
            'appid' => $item->appid,
            'gzh_code' => $item->gzh_code,
            'gzh_img' => $item->gzh_img,
            'gzh_name' => $item->gzh_name,
            'sub_img' => $item->sub_img,
            'company_name' => $item->company_name,
            'domain' => $item->domain,
            'status' => $item->status,
            'content' => $item->content,
            'remark' => $item->remark,
            'cdn_link' => $item->cdn_link,
            'link_source' => $item->link_source,
            'landing_page_link' => ($item->cdn_link ? $this->getLandingPageLink($item) : ''),
        ];
    }

    protected function getLandingPageLink(LandingPageLink $model)
    {
        switch ($model->link_source) {
            case 'baidu':
                $adid = $model->adAccount ? $model->adAccount->id : 0;
                return "{$model->cdn_link}?dycallback=8&channel_id={$model->channel_id}&adid={$adid}";
            case 'kuaishou':
                return "{$model->cdn_link}?dycallback=6&channel_id={$model->channel_id}";
            default:
                return "{$model->cdn_link}?dycallback=1&channel_id={$model->channel_id}&link_source={$model->link_source}";
        }
    }
}
