<?php

namespace General\Services\Report;

use General\Models\Report\ReportUserBindRecord;

/**
 * 快手数据上报
 */
class KuaishouReport extends BaseReport
{
    public function __construct()
    {
        $this->charge_event_type = 3;
        $this->register_event_type = 1;
        $this->report_url = 'http://ad.partner.gifshow.com/track/activate';
    }

    private function getCallback(string $link)
    {
        preg_match('/&callback=([^&\s]+)&?/i', $link, $callback_arr);
        if ($callback_arr) {
            return $callback_arr[1];
        } else {
            return '';
        }
    }

    public function getChargeQueryParams(ReportUserBindRecord $user, float $amount): array
    {
        return  [
            'callback' => $this->getCallback($user->link),
            'event_type' => $this->charge_event_type,
            'event_time' => time() * 1000,
            'purchase_amount' => $amount,
        ];
    }

    public function getRegisterQueryParams(ReportUserBindRecord $user): array
    {
        return  [
            'callback' => $this->getCallback($user->link),
            'event_type' => $this->register_event_type,
            'event_time' => time() * 1000,
            'source' => $user->source,
        ];
    }
}
