<?php

namespace General\Services\Report;

use General\Models\Report\ReportUserBindRecord;
use App\Consts\BaseConst;

/**
 * 快手数据上报
 */
class QappKuaishouReport extends BaseReport
{

    public function __construct()
    {
        $this->charge_event_type = 3;
        $this->register_event_type = 1;
        $this->report_url = 'http://ad.partner.gifshow.com/track/activate';
    }


    public function getRegisterQueryParams(ReportUserBindRecord $user): array
    {
        return [
            'callback' => $user->callback,
            'event_type' => $this->register_event_type,
            'event_time' => time() * 1000,
            'source' => BaseConst::Platform,
        ];
    }

    public function getChargeQueryParams(ReportUserBindRecord $user, float $amount): array
    {
        return [
            'callback' => $user->callback,
            'event_type' => $this->charge_event_type,
            'event_time' => time() * 1000,
            'purchase_amount' => $amount,
        ];
    }
}
