<?php

namespace General\Services\Report;

use General\Models\Report\ReportUserBindRecord;

/**
 * UC数据上报
 */
class WeiboReport extends BaseReport
{
    public function __construct()
    {
        $this->register_event_type = 5;
        $this->charge_event_type = 6;
        $this->report_url = 'https://appmonitor.biz.weibo.com/sdkserver/active';
    }

    private function getIMP(string $link)
    {
        preg_match('/&?IMP=([^&\s]+)&?/i', $link, $imp_arr);
        if ($imp_arr) {
            return $imp_arr[1];
        } else {
            return '';
        }
    }

    public function getChargeQueryParams(ReportUserBindRecord $user, float $amount): array
    {
        return  [
            'IMP' => $this->getIMP($user->link),
            'action_type' => $this->charge_event_type,
            'active_time' => time(),
        ];
    }

    public function getRegisterQueryParams(ReportUserBindRecord $user): array
    {
        return  [
            'IMP' => $this->getIMP($user->link),
            'action_type' => $this->register_event_type,
            'active_time' => time(),
        ];
    }
}
